<?php
namespace Planejamento\Entities;

use Geral\Util\Ambiente;
use Geral\Util\DateUtil;

class Planprodfiliagrega extends Base\Planprodfiliagrega
{
    public static function buscaQuantidade(
        $nrorg, $nrplanprod, $cdprodacabado,
        $cdfiliagreg, $cdservfiliagreg, $dtconsumo
    )
    {
        $qtprodserv = Planprodfiliagrega::getObjectByWhere(
            'NRORG = ? AND NRPLANPROD = ? AND CDPRODACABADO = ? AND
            CDFILIAGREG = ? AND CDSERVFILIAGREG = ? AND DTCONSUMO = ?',
            array(
                $nrorg, $nrplanprod, $cdprodacabado,
                $cdfiliagreg, $cdservfiliagreg, $dtconsumo
            )
        );
        return $qtprodserv;
    }

    public static function atualizaCusto(
        $nrorg, $nrplanprod, $cdprodacabado,
        $cdfiliagreg, $cdservfiliagreg, $dtconsumo, $vtotalcusto
    )
    {
        try {
            $objPlanprod = Planprodfiliagrega::getObjectByWhere(
                'NRORG = ? AND NRPLANPROD = ? AND CDPRODACABADO = ? AND
                CDFILIAGREG = ? AND CDSERVFILIAGREG = ? AND DTCONSUMO = ?',
                array(
                    $nrorg, $nrplanprod, $cdprodacabado,
                    $cdfiliagreg, $cdservfiliagreg, $dtconsumo
                )
            );

            $objPlanprod->setVrtotalprodserv($vtotalcusto);
            $qtcomensais = $objPlanprod->getQtcomensserv();
            if ($qtcomensais > 0) {
                $objPlanprod->setVrunitprodserv(($vtotalcusto/$qtcomensais));
            } else {
                $objPlanprod->setVrunitprodserv(0);
            }
            $objPlanprod->setNrorgultatu($nrorg);
            $objPlanprod->setCdoperultatu(Ambiente::getCdOperador());
            $objPlanprod->setDtultatu(DateUtil::getDataAtual());

            $objPlanprod->persist();

            return true;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function atualizaQuantidade(
        $nrorg, $nrplanprod, $cdprodacabado,
        $cdfiliagreg, $cdservfiliagreg, $dtconsumo, $qtReceita, $vrReceita
    )
    {
        try {
            $objPlanprod = Planprodfiliagrega::getObjectByWhere(
                'NRORG = ? AND NRPLANPROD = ? AND CDPRODACABADO = ? AND
                CDFILIAGREG = ? AND CDSERVFILIAGREG = ? AND DTCONSUMO = ?',
                array(
                    $nrorg, $nrplanprod, $cdprodacabado,
                    $cdfiliagreg, $cdservfiliagreg, $dtconsumo
                )
            );
            $vtotalcusto = $objPlanprod->getVrtotalprodserv() + $vrReceita;
            $objPlanprod->setVrtotalprodserv($vtotalcusto);
            $qtcomensais = $objPlanprod->getQtcomensserv();
            if ($qtcomensais > 0) {
                $objPlanprod->setVrunitprodserv(($vtotalcusto/$qtcomensais));
            } else {
                $objPlanprod->setVrunitprodserv(0);
            }
            $qtprodserv = $objPlanprod->getQtprodserv() + $qtReceita;
            $objPlanprod->setQtprodserv($qtprodserv);

            $objPlanprod->setNrorgultatu($nrorg);
            $objPlanprod->setCdoperultatu(Ambiente::getCdOperador());
            $objPlanprod->setDtultatu(DateUtil::getDataAtual());

            $objPlanprod->persist();

            return true;
        } catch (\Exception $e) {
            throw $e;
        }
    }

}
